image: node:10.15.3

services:
  - mongo:4.0.9

variables:
  # Configure postgres service (https://hub.docker.com/_/postgres/)
  MONGO_INITDB_DATABASE: $DB_NAME
  MONGO_INITDB_ROOT_USERNAME: $DB_USER
  MONGO_INITDB_ROOT_PASSWORD: $DB_PASS

connect_db:
  stage: staging
  image: mongo:4.0.9
  script:
    # official way to connect to mongodb https://docs.mongodb.com/manual/reference/program/mongo/#bin.mongo
    - mongo "mongodb://mongo:27017/$DB_NAME"

cache:
    paths:
    - node_modules/
    - src/client/node_modules/

stages:
- staging
- deploy

install_dependencies:
    stage: staging
    script: 
        - npm install
        - npm run build

deploy:server:
    image: ruby
    stage: deploy
    type: deploy
    variables:
      APP_NAME: farivsblog
      HEROKU_API_KEY: $FARIVSBLOG_HEROKU_API_KEY
    before_script:
      - gem install dpl
    script:
      - dpl --provider=heroku --app=$APP_NAME --api-key=$HEROKU_API_KEY
    only:
      - master